"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("react/jsx-runtime");
var react_1 = require("react");
var index_1 = __importDefault(require("./index"));
var each_1 = __importDefault(require("licia/each"));
var hooks_1 = require("../share/hooks");
var LunaDataGrid = function (props) {
    var dataGridRef = (0, react_1.useRef)(null);
    var dataGrid = (0, react_1.useRef)();
    var prevProps = (0, hooks_1.usePrevious)(props);
    (0, react_1.useEffect)(function () {
        dataGrid.current = new index_1.default(dataGridRef.current, {
            columns: props.columns,
            height: props.height,
            maxHeight: props.maxHeight,
            minHeight: props.minHeight,
            filter: props.filter,
            selectable: props.selectable,
            theme: props.theme,
        });
        dataGrid.current.setData(props.data, props.uniqueId);
    }, []);
    (0, hooks_1.useNonInitialEffect)(function () {
        if (dataGrid.current) {
            dataGrid.current.setData(props.data, props.uniqueId);
        }
    }, [props.data]);
    (0, hooks_1.useEvent)(dataGrid, 'select', prevProps === null || prevProps === void 0 ? void 0 : prevProps.onSelect, props.onSelect);
    (0, hooks_1.useEvent)(dataGrid, 'deselect', prevProps === null || prevProps === void 0 ? void 0 : prevProps.onDeselect, props.onDeselect);
    (0, hooks_1.useEvent)(dataGrid, 'click', prevProps === null || prevProps === void 0 ? void 0 : prevProps.onClick, props.onClick);
    (0, hooks_1.useEvent)(dataGrid, 'dblclick', prevProps === null || prevProps === void 0 ? void 0 : prevProps.onDoubleClick, props.onDoubleClick);
    (0, hooks_1.useEvent)(dataGrid, 'contextmenu', prevProps === null || prevProps === void 0 ? void 0 : prevProps.onContextMenu, props.onContextMenu);
    (0, each_1.default)(['theme', 'height', 'maxHeight', 'minHeight', 'filter'], function (key) {
        (0, hooks_1.useOption)(dataGrid, key, props[key]);
    });
    return (0, jsx_runtime_1.jsx)("div", { className: props.className || '', ref: dataGridRef });
};
exports.default = LunaDataGrid;
